'use strict';

var _extends = require('@babel/runtime/helpers/extends');
var _objectWithoutPropertiesLoose = require('@babel/runtime/helpers/objectWithoutPropertiesLoose');
var jsx = require('@babel/plugin-transform-react-jsx');
var pragmatic = require('@emotion/babel-plugin-jsx-pragmatic');
var emotion = require('babel-plugin-emotion');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _extends__default = /*#__PURE__*/_interopDefaultLegacy(_extends);
var _objectWithoutPropertiesLoose__default = /*#__PURE__*/_interopDefaultLegacy(_objectWithoutPropertiesLoose);
var jsx__default = /*#__PURE__*/_interopDefaultLegacy(jsx);
var pragmatic__default = /*#__PURE__*/_interopDefaultLegacy(pragmatic);
var emotion__default = /*#__PURE__*/_interopDefaultLegacy(emotion);

var pragmaName = '___xstyledEmotionJSX'; // pull out the emotion options and pass everything else to the jsx transformer
// this means if @babel/plugin-transform-react-jsx adds more options, it'll just work
// and if babel-plugin-emotion adds more options we can add them since this lives in
// the same repo as babel-plugin-emotion

var index = (function (api, _temp) {
  var _ref = _temp === void 0 ? {} : _temp,
      pragma = _ref.pragma,
      sourceMap = _ref.sourceMap,
      autoLabel = _ref.autoLabel,
      labelFormat = _ref.labelFormat,
      _ref$instances = _ref.instances,
      instances = _ref$instances === void 0 ? [] : _ref$instances,
      options = _objectWithoutPropertiesLoose__default['default'](_ref, ["pragma", "sourceMap", "autoLabel", "labelFormat", "instances"]);

  return {
    plugins: [[pragmatic__default['default'], {
      "export": 'jsx',
      module: '@xstyled/emotion',
      "import": pragmaName
    }], [jsx__default['default'], _extends__default['default']({
      pragma: pragmaName,
      pragmaFrag: 'React.Fragment'
    }, options)], [emotion__default['default'], {
      sourceMap: sourceMap,
      autoLabel: autoLabel,
      labelFormat: labelFormat,
      instances: ['@xstyled/emotion'].concat(instances),
      cssPropOptimization: true
    }]]
  };
});

module.exports = index;
